import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import org.jdom.output.*;

public class aggiornaElenchi {

	static Vector fileDaAggiornare=new Vector();
	static Vector nuoviUtenti=new Vector();

	static String replace(String input, char a, String b){
		String out=new String(input);
		for(int i=0; i<input.length();i++){
			if((i==0)&&(input.charAt(i)==a)){
				out=b+replace(out.substring(1),a,b);
				break;
			}

			if((i==input.length()-1)&&(input.charAt(i)==a)){
				out=replace(out.substring(0,i),a,b)+b;
				break;
			}

			else if(input.charAt(i)==a){
				out=replace(out.substring(0,i),a,b)+b+replace(out.substring(i+1),a,b);
				break;
			}
		}
		return out;
		}
	
	static String converti(String plain){
		XMLOutputter jdom=new XMLOutputter();
		String out=new String(jdom.outputString(plain));
		for(int oldCh=0,newCh=0; (oldCh<96)&&(newCh<96); oldCh++,newCh++){
			out=replace(out, (char)('\u00a0'+oldCh+0x0000),"&#"+(160+newCh)+";");
		}
		return out;
		}

	
private static String estraiCampo(String testo){
	int i=testo.indexOf('=');
	return testo.substring(i+1).trim();
}

private static void rimuoviRoot(String fileName){
File file=new File(fileName);
byte[] bytes=new byte[(int)file.length()-9];
try{
	FileInputStream fis=new FileInputStream(fileName);
		fis.read(bytes);
		BufferedOutputStream fos=new BufferedOutputStream(
		new FileOutputStream(fileName));
		fos.write(bytes,0,bytes.length);
		fos.flush();
	}catch(Exception e){System.out.println(""+e.getMessage());}
}
	
  public static void processa(String msg, String fine){
  	
	BufferedReader br=new BufferedReader(new StringReader(msg));
	String linea=null, testo="";
	String regione=null, provincia=null, nome=null, mail=null,
			tel=null, paese=null, sito=null;
	String[] generi=new String[8];
	String[] strumenti=new String[7];
	int i=0, j=0;
	
   try{
	while(!(linea=br.readLine()).startsWith("nome="));
	nome=estraiCampo(linea);
	
	linea=br.readLine();
	mail=estraiCampo(linea);

	if(nuoviUtenti.indexOf(mail)==-1)
	nuoviUtenti.add(mail);

	linea=br.readLine();
	sito=estraiCampo(linea);
	
	linea=br.readLine();
	tel=estraiCampo(linea);
	
	linea=br.readLine();
	paese=estraiCampo(linea);

	linea=br.readLine();
	regione=estraiCampo(linea);
	
	if(fileDaAggiornare.indexOf(regione+fine)==-1)
	fileDaAggiornare.add(regione+fine);
	
	linea=br.readLine();
	provincia=estraiCampo(linea);
	
	while((linea=br.readLine()).startsWith("genere")){
	generi[i]=estraiCampo(linea);
	i++;
	}

	while(linea.startsWith("strumento")){
		strumenti[j]=estraiCampo(linea);
		j++;
		linea=br.readLine();
	}

	int numLinea=0;
	while(numLinea<20){
		linea=estraiCampo(linea);
		testo+=linea;
		linea=br.readLine();
		if((linea==null)||(linea.startsWith("--")))break;
		testo+="\n";
		numLinea++;
	}
   }catch(Exception e){System.out.println(""+e.getMessage());}
    
	File file=null;
	PrintStream printStream=null;
	file=new File(regione+fine);
	FileOutputStream fos=null;
	
		try{
		fos=new FileOutputStream(""+regione+fine,true);
		printStream=new PrintStream(fos,true);
        		}catch(Exception e){System.out.println(""+e.getMessage());}

	if(file.length()==0){
		printStream.println("<?xml version=\"1.0\"?>\n<?xml-stylesheet type=\"text/xsl\" href=\"elenchi"+fine.charAt(0)+".xsl\"?>");
		printStream.println("");
		printStream.println("<root>");
		printStream.println("");
	}
	else rimuoviRoot(regione+fine);
	
	printStream.println("<"+(fine.charAt(0)=='b'?"BAND":"MUSICISTA")+
						" nome=\""+converti(nome)+"\""+
						" mail=\""+converti(mail)+"\""+
						" sito=\""+converti(sito)+"\""+
						" tel=\""+converti(tel)+"\""+
						" paese=\""+converti(paese)+"\""+
						" provincia=\""+converti(provincia)+"\""+">");
	
	for(int indiceGeneri=0;indiceGeneri<i;indiceGeneri++)
	printStream.println("<genere>"+converti(generi[indiceGeneri])+"</genere>");
	
	if(fine.charAt(0)=='m')for(int indiceStrumenti=0;indiceStrumenti<j;indiceStrumenti++)
	printStream.println("<strumento>"+converti(strumenti[indiceStrumenti])+"</strumento>");

	printStream.println("<testo>"+converti(testo)+"</testo>");
	
	printStream.println("</"+(fine.charAt(0)=='b'?"BAND":"MUSICISTA")+">");
	printStream.println("");
	printStream.println("</root>");
	
	try{
	fos.close();
	}catch(Exception e){System.out.println(""+e.getMessage());
							System.exit(-1);}
  }

  public static void main (String args[]) throws Exception {

  	String host = "pop.iol.it";

	// Setup empty properties
	Properties props = new Properties();

	// Get session
	Session session = Session.getDefaultInstance(props, null);

	// Get the store
	Store store = session.getStore("pop3");
	store.connect(host, tuo_username_posta, tua_password_posta);

    // Get folder
    Folder folder = store.getFolder("INBOX");
    folder.open(Folder.READ_WRITE);

    // Get directory
    Message message[] = folder.getMessages();
    for (int i=0, n=message.length; i<n; i++) {

       System.out.println(i + ": " + message[i].getFrom()[0] 
         + "\t" + message[i].getSubject());
       String content = message[i].getContent().toString();
       System.out.print(content);

	if(message[i].getSubject().equals("form band")){
	processa(message[i].getContent().toString(), "b.xml");
	message[i].setFlag(Flags.Flag.DELETED, true);
	}
	
	else if(message[i].getSubject().equals("form musicisti")){
	processa(message[i].getContent().toString(), "m.xml");
	message[i].setFlag(Flags.Flag.DELETED, true);
	}

    }
	
	//fileDaAggiornare ora contiene tutti i nomi dei file da aggiornare
	
    // Close connection 
    folder.close(true);
    store.close();

String[] env=new String[4];
env[0]="/Pfoo=bar";
String str;

	for(int x=0;x<fileDaAggiornare.size();x++){
	env[1]=(String)(fileDaAggiornare.elementAt(x));
	env[2]="elenchi"+(env[1].charAt(env[1].length()-5))+".xsl";
	env[3]=env[1].substring(0,env[1].length()-4)+".htm";


	Process proc = Runtime.getRuntime().exec("C:\\zibal\\xsltProcessor\\files\\uxt "+env[0]+" "+env[1]+" "+env[2]+" "+env[3]);
	BufferedReader in = new BufferedReader(new InputStreamReader(
                                         proc.getInputStream()));
	BufferedReader err = new BufferedReader(new InputStreamReader(
                                         proc.getErrorStream()));
    
	try {

	while ((str = in.readLine()) != null) {
		    System.out.println(str);
		}
	while ((str = err.readLine()) != null) {
		    System.out.println(str);
		}

	}catch (IOException e) {
		System.exit(0);
		}
	
	proc.waitFor();
	}

	//parte FTP
	PrintStream ftpFile=new PrintStream(new FileOutputStream(
        			"ftpFile.txt",false),true);
    ftpFile.println("open ftp.digiland.it");
    ftpFile.println(tuo_username_ftp);
	ftpFile.println(Tua_password_ftp);
	ftpFile.println("binary");
	ftpFile.println("cd elenchi");
	
	for(int nf=0;nf<fileDaAggiornare.size();nf++){
	String currFile=((String)(fileDaAggiornare.elementAt(nf))).substring(
	  0,((String)(fileDaAggiornare.elementAt(nf))).length()-4)+".htm";
	ftpFile.println("delete "+currFile);
	ftpFile.println("send "+currFile);
	}
	
	ftpFile.println("quit");
	
  	
  	if(nuoviUtenti.size()>0){
	PrintStream notificheFile=new PrintStream(new FileOutputStream(
        			"notificheFile.txt",false),true);
    	
	for(int nu=0;nu<nuoviUtenti.size();nu++)
	notificheFile.println(""+nuoviUtenti.elementAt(nu));
	}
  
  System.exit(0);
  
  }
}